package com.subd.subd.Controllers;

import com.subd.subd.Models.Driver;
import com.subd.subd.Services.DriverService;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class DriverController {
    private final DriverService DriverService;
    public DriverController(DriverService DriverService) {
        this.DriverService = DriverService;
    }
    @GetMapping("/driver/{id}")
    public Driver getDriver(@PathVariable Long id) {
        return DriverService.findDriver(id);
    }
    @GetMapping("/driver")
    public List<Driver> getDrivers() {
        return DriverService.findAllDrivers();
    }
    @PostMapping("/driver")
    public Driver createDriver(@RequestBody Driver driver) {
        return DriverService.addDriver(driver.getName(), driver.getBirthday(), driver.getPhone(), driver.getEmail());
    }
    @PutMapping("/driver/{id}")
    public Driver updateDriver(@PathVariable Long id, @RequestBody Driver driver) {
        return DriverService.updateDriver(id, driver.getName(), driver.getBirthday(), driver.getPhone(), driver.getEmail());
    }
    @DeleteMapping("/driver/{id}")
    public Driver deleteDriver(@PathVariable Long id) {
        return DriverService.deleteDriver(id);
    }
}
