package com.subd.subd.Models;

import com.subd.subd.Dtos.CarDto;
import jakarta.persistence.*;

import java.util.Objects;

@Entity
@Table(name = "Car")
public class Car {
    @Id
    @GeneratedValue
    private Long id;
    private String gosNumber;
    private String vin;
    @OneToOne()
    @JoinColumn(name = "Driver_id", referencedColumnName = "id")
    private Driver driver;
    Car() {}
    public Car(String gosNumber, String vin, Driver driver) {
        this.gosNumber = gosNumber;
        this.vin = vin;
        this.driver = driver;
    }
    public Car(CarDto carDto) {
        this.gosNumber = carDto.getGosNumber();
        this.vin = carDto.getVin();
    }
    public Long getId() {
        return this.id;
    }
    public void setId(Long id) {
        this.id = id;
    }
    public String getGosNumber() {
        return this.gosNumber;
    }
    public void setGosNumber(String gosNumber) {
        this.gosNumber = gosNumber;
    }
    public String getVin() {
        return this.vin;
    }
    public void setVin(String vin) {
        this.vin = vin;
    }
    public Driver getDriver() {
        return this.driver;
    }
    public void setDriver(Driver driver) {
        this.driver = driver;
    }
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Car))
            return false;
        Car car = (Car) o;
        return Objects.equals(this.id, car.id) &&
                Objects.equals(this.gosNumber, car.gosNumber) &&
                Objects.equals(this.vin, car.vin) &&
                Objects.equals(this.driver, car.driver);
    }
    @Override
    public int hashCode() {
        return Objects.hash(this.id, this.gosNumber, this.vin, this.driver);
    }
    @Override
    public String toString() {
        return "Car{" + "id=" + this.id +
                ", gosNumber='" + this.gosNumber + '\'' +
                ", vin='" + this.vin + '\'' +
                ", driver='" + this.driver + '\'' +
                '}';
    }
}
