package com.subd.subd.Models;

import jakarta.annotation.Nullable;
import jakarta.persistence.*;

import java.util.Date;
import java.util.Objects;

@Entity
@Table(name = "\"Order\"")
public class Order {
    @Id
    @GeneratedValue
    private Long id;
    private Double value;
    private String status;
    private Date date;
    @ManyToOne( cascade = {CascadeType.MERGE}, fetch = FetchType.EAGER)
    @JoinColumn(name = "Client_id", nullable = true)
    private Client client;
    @OneToOne()
    @JoinColumn(name = "sourcePickUpPoint_id", referencedColumnName = "id")
    private PickUpPoint sourcePickUpPoint;
    @Nullable
    @OneToOne()
    @JoinColumn(name = "destPickUpPoint_id", referencedColumnName = "id")
    private PickUpPoint destPickUpPoint;
    @OneToOne()
    @JoinColumn(name = "Car_id", referencedColumnName = "id")
    private Car car;
    Order() {}
    public Order(Double value, String status, Date date, Client client, PickUpPoint sourcePickUpPoint, @Nullable PickUpPoint destPickUpPoint, Car car) {
        this.value = value;
        this.status = status;
        this.date = date;
        this.client = client;
        this.sourcePickUpPoint = sourcePickUpPoint;
        this.destPickUpPoint = destPickUpPoint;
        this.car = car;
    }
    public Long getId() {
        return this.id;
    }
    public void setId(Long id) {
        this.id = id;
    }
    public Double getValue() {
        return this.value;
    }
    public void setValue(Double value) {
        this.value = value;
    }
    public String getStatus() {
        return this.status;
    }
    public void setStatus(String status) {
        this.status = status;
    }
    public Date getDate() {
        return this.date;
    }
    public void setDate(Date date) {
        this.date = date;
    }
    public Client getClient() {
        return client;
    }
    public void setClient(Client client) {
        this.client = client;
    }
    public Client removeClient() {
        Client temp = this.client;
        this.client = null;
        return temp;
    }
    public PickUpPoint getSourcePickUpPoint() {
        return this.sourcePickUpPoint;
    }
    public void setSourcePickUpPoint(PickUpPoint sourcePickUpPoint) {
        this.sourcePickUpPoint = sourcePickUpPoint;
    }
    public PickUpPoint getDestPickUpPoint() {
        return this.destPickUpPoint;
    }
    public void setDestPickUpPoint(PickUpPoint destPickUpPoint) {
        this.destPickUpPoint = destPickUpPoint;
    }
    public Car getCar() {
        return this.car;
    }
    public void setCar(Car car) {
        this.car = car;
    }
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Client))
            return false;
        Order order = (Order) o;
        return Objects.equals(this.id, order.id) &&
                Objects.equals(this.value, order.value) &&
                Objects.equals(this.status, order.status) &&
                Objects.equals(this.client, order.client) &&
                Objects.equals(this.sourcePickUpPoint, order.sourcePickUpPoint) &&
                Objects.equals(this.destPickUpPoint, order.destPickUpPoint) &&
                Objects.equals(this.car, order.car);
    }
    @Override
    public int hashCode() {
        return Objects.hash(this.id, this.value, this.status, this.client, this.sourcePickUpPoint, destPickUpPoint, car);
    }
    @Override
    public String toString() {
        return "Client{" + "id=" + this.id +
                ", value='" + this.value + '\'' +
                ", status='" + this.status + '\'' +
                ", client='" + this.client + '\'' +
                ", sourcePickUpPoint='" + this.sourcePickUpPoint + '\'' +
                ", destPickUpPoint='" + this.destPickUpPoint + '\'' +
                ", car='" + this.car + '\'' +
                '}';
    }
}
