import { createApp } from 'vue'
import { createRouter, createWebHistory } from 'vue-router'
import './style.css'
import App from './App.vue'
import Orders from './components/Orders.vue'
import Generator from './components/Generator.vue'

const routes = [
    { path: '/', redirect: '/orders' },
    { path: '/orders', component: Orders, meta: { label: 'Заказы' }},
    { path: '/generator', component: Generator, meta: { label: 'Генератор' }}
]

const router = createRouter({ 
    history: createWebHistory(),
    linkActiveClass: 'active',
    routes
})
createApp(App).use(router).mount('#app')