export default class Car {
    constructor(data) {
        this._id = data?.id;
        this._gosNumber = data?.gosNumber;
        this._vin = data?.vin;
        this._driver = data?.driver;
        this._driverId = data?.driver.id;
    }

    get id() {
        return this._id;
    }

    get gosNumber() {
        return this._gosNumber;
    }

    set gosNumber(value) {
        if (typeof value !== 'string' || value === null || value.length == 0) {
            throw 'New gos number value ' + value + ' is not a string or empty';
        }
        this._gosNumber = value;
    }

    get vin() {
        return this._vin;
    }

    set vin(value) {
        if (typeof value !== 'string' || value === null || value.length == 0) {
            throw 'New vin value ' + value + ' is not a string or empty';
        }
        this._vin = value;
    }

    get driverId() {
        return this._driverId;
    }

    set driverId(value) {
        this._driverId = value;
    }

    get driverName() {
        return this.driver?.name;
    }
}